
; ---------------------------------------------------------------- 
;   PPU WX^                                                   
; ---------------------------------------------------------------- 
PPU_REG_CTRL1		=	$2000				; 䃌WX^P
PPU_CTRL1_INT		=	1<<7				; VSync 荞݋
PPU_CTRL1_SPR8		=	0<<5				; XvCgTCY 8x8
PPU_CTRL1_SPR16		=	1<<5				; XvCgTCY 8x16
PPU_CTRL1_BG0		=	0<<4				; BG LN^[e[uAhX $0000
PPU_CTRL1_BG1		=	1<<4				; BG LN^[e[uAhX $1000
PPU_CTRL1_SPR0		=	0<<3				; XvCgLN^[e[uAhX $0000
PPU_CTRL1_SPR1		=	1<<3				; XvCgLN^[e[uAhX $1000
PPU_CTRL1_ADD1		=	0<<2				; VRAM ANZX̃AhXʂP
PPU_CTRL1_ADD32		=	1<<2				; VRAM ANZX̃AhX32
PPU_CTRL1_NT0		=	0<<0				; CXN[AhX $2000
PPU_CTRL1_NT1		=	1<<0				; CXN[AhX $2400
PPU_CTRL1_NT2		=	2<<0				; CXN[AhX $2800
PPU_CTRL1_NT3		=	3<<0				; CXN[AhX $2C00

PPU_REG_CTRL2		=	$2001				; 䃌WX^Q
PPU_CTRL2_R		=	1<<7				; ԐF
PPU_CTRL2_G		=	1<<6				; ΐF
PPU_CTRL2_B		=	1<<5				; F
PPU_CTRL2_SPR		=	1<<4				; XvCg̕\
PPU_CTRL2_BG		=	1<<3				; BG ̕\
PPU_CTRL2_LSPR		=	1<<2				; ʍ[WsNZ̃XvCg\
PPU_CTRL2_LBG		=	1<<1				; ʍ[WsNZ̔wi\
PPU_CTRL2_MONO		=	1<<0				; Fݒ

PPU_REG_STATUS		=	$2002				; Xe[^XWX^
PPU_STATUS_VBLANK	=	1<<7				; XN[̕`
PPU_STATUS_SPRHIT	=	1<<6				; `XLĈOԃXvCgqbg
PPU_STATUS_SPROVR	=	1<<5				; `XLC̃XvCgѐ

PPU_REG_SPRADDR		=	$2003				; XvCgAhXWX^
PPU_REG_SPRDATA		=	$2004				; XvCgANZXWX^
PPU_REG_SCROLL		=	$2005				; XN[WX^
PPU_REG_VRAMADDR	=	$2006				; VRAM AhXWX^
PPU_REG_VRAMDATA	=	$2007				; VRAM ANZXWX^


; ---------------------------------------------------------------- 
;   APU WX^                                                   
; ---------------------------------------------------------------- 


; ---------------------------------------------------------------- 
;   PPU AhX                                                   
; ---------------------------------------------------------------- 
PPU_PAT			=	$0000				; p^[e[u
PPU_NT0			=	$2000				; ʂPl[e[u
PPU_AT0			=	$23C0				; ʂPe[u
PPU_NT1			=	$2400				; ʂQl[e[u
PPU_AT1			=	$27C0				; ʂQe[u
PPU_NT2			=	$2800				; ʂRl[e[u
PPU_AT2			=	$2BC0				; ʂRe[u
PPU_NT3			=	$2C00				; ʂSl[e[u
PPU_AT3			=	$2FC0				; ʂSe[u
PPU_BGPAL		=	$3F00				; BG pbge[u
PPU_SPRPAL		=	$3F10				; XvCgpbge[u


; ---------------------------------------------------------------- 
;   TCB                                                        
; ---------------------------------------------------------------- 
TCB_STATUS_DEL		=	1<<7				; 폜


; ---------------------------------------------------------------- 
;   pbh                                                     
; ---------------------------------------------------------------- 
PAD_A			=	1<<7
PAD_B			=	1<<6
PAD_SELECT		=	1<<5
PAD_START		=	1<<4
PAD_UP			=	1<<3
PAD_DOWN		=	1<<2
PAD_LEFT		=	1<<1
PAD_RIGHT		=	1<<0




; ------------------------------------------------------------------------------------------------ 
;   [y[W                                                                                     

	.ZP

TEMP:								; e|
SRCADDR			.DS	2				; \[XAhX
			.DS	2
BGBUFF_COUNT		.DS	1				; BG obt@gp
SCROLL_XPOS		.DS	1				; XN[W
SCROLL_YPOS		.DS	1				; XN[W
PREV_TCB		.DS	1				; O^XN TCB ԍ
RUN_TCB			.DS	1				; ŝ TCB ԍ
TCB_COUNT		.DS	1				; c TCB 
PAD_NORM		.DS	1				; pbhԒʏ
PAD_OLD			.DS	1				; pbhԑO
PAD_ONCE		.DS	1				; pbhԂPx̂
PAD_REPT		.DS	1				; pbhԌJԂ
PAD_REPTTIME		.DS	1				; pbhԌJԂ




; ------------------------------------------------------------------------------------------------ 
;   BSS                                                                                            

	.BSS
	.ORG	$100

BGBUFF:			.DS	BGBUFF_SIZE			; BG obt@
UNUSED_TCB		.DS	TASK_MAX-1			; gp^XNԍ
;#REG_VALUE:		.DS	24				; WX^l
STACK:			.DS	256-LOW(STACK)			; X^bN
SPRBUF:			.DS	256				; XvCgobt@
TCB0:			.DS	256				; TCB0
TCB1:			.DS	256				; TCB1

; TCB
TCB_STATUS		=	TCB0+0				; 
TCB_NEXT		=	TCB0+1				;  TCB ԍ
TCB_PROC		=	TCB0+2				; 




; ------------------------------------------------------------------------------------------------ 
;   荞݃xN^e[u                                                                         

	.CODE
	.BANK	PRG_BANK_MAX-1
	.ORG	$FFFA

INTVECT_TBL:
	.DW	ISR_VSYNC
	.DW	RESET
	.DW	ISR_IRQBRK




; ------------------------------------------------------------------------------------------------ 
;   Zbg                                                                                       

	.CODE
	.BANK	0
	.ORG	$8000
RESET:
; ------------------------------------------------ 
;   PPU                                      
; ------------------------------------------------ 
INIT_PPU:
	LDX	#$00
	STX	PPU_REG_CTRL1
	STX	PPU_REG_CTRL2

INIT_PPU_100:
	LDX	PPU_REG_STATUS
	BPL	INIT_PPU_100

; ------------------------------------------------ 
;   pbg                                 
; ------------------------------------------------ 
INIT_PAL:
	LDX	#HIGH(PPU_BGPAL)
	LDY	#LOW(PPU_BGPAL)
	STX	PPU_REG_VRAMADDR
	STY	PPU_REG_VRAMADDR
	LDX	#$00
INIT_PAL_100:
	LDA	INITPALDAT,X
	STA	PPU_REG_VRAMDATA
	INX
	CPX	#32
	BNE	INIT_PAL_100

; ------------------------------------------------ 
;   l[Ee[u                     
; ------------------------------------------------ 
INIT_NT_ATTR:
	LDX	#HIGH(PPU_NT0)
	LDY	#HIGH(PPU_NT0)
	STX	PPU_REG_VRAMADDR
	STY	PPU_REG_VRAMADDR

	LDA	#$00
	LDX	#HIGH($0800)+1
	LDY	#LOW($0800)
INIT_NT_ATTR_100:
	STA	PPU_REG_VRAMDATA
	DEY
	BNE	INIT_NT_ATTR_100
	DEX
	BNE	INIT_NT_ATTR_100

; ------------------------------------------------ 
;   RAM                                      
; ------------------------------------------------ 
INIT_RAM:
	STA	$0000,X
	STA	$0100,X
	STA	$0200,X
	STA	$0300,X
	STA	$0400,X
	STA	$0500,X
	STA	$0600,X
	STA	$0700,X
	INX
	BNE	INIT_RAM

; ------------------------------------------------ 
;   gp^XNԍ쐬                           
; ------------------------------------------------ 
CREATE_UNUSEDTCB:
	LDA	#8
	LDX	#TASK_MAX-1
	STX	TCB_COUNT
	DEX
	CLC
CREATE_UNUSEDTCB_100:
	STA	UNUSED_TCB,X
	ADC	#8
	DEX
	BPL	CREATE_UNUSEDTCB_100


; ------------------------------------------------ 
;                                            
; ------------------------------------------------ 
	; X^bNݒ
	LDX	#$FF
	TXS

	; VXe^XN쐬
	LDX	#0
	LDA	#LOW(SYSTEM_TSK-1)
	STA	TCB_PROC+0,X
	LDA	#HIGH(SYSTEM_TSK-1)
	STA	TCB_PROC+1,X

	; XvCg
	LDA	#HIGH(SPRBUF)
	STA	$4014

	; 
	JSR	INIT

	; PPU ݒ
	LDA	#(PPU_CTRL2_SPR|PPU_CTRL2_BG|PPU_CTRL2_LSPR|PPU_CTRL2_LBG)
	STA	PPU_REG_CTRL2
	LDA	#(PPU_CTRL1_INT|PPU_CTRL1_SPR8|PPU_CTRL1_BG0|PPU_CTRL1_SPR0|PPU_CTRL1_ADD1|PPU_CTRL1_NT0)
	STA	PPU_REG_CTRL1

; ------------------------------------------------ 
;   VSync ҂                                     
; ------------------------------------------------ 
WAIT_VSYNC:
	JMP	WAIT_VSYNC




; ------------------------------------------------------------------------------------------------ 
;   VSync 荞݃T[rX[`                                                                 

ISR_VSYNC:
	; XvCg]
	.IF	SPRDMA = 1
	LDA	#HIGH(SPRBUF)
	STA	$4014
	.ENDIF

; ------------------------------------------------ 
;   BG `                                        
; ------------------------------------------------ 
DRAW_BG:
	LDY	#0

	; f[^
	LDX	BGBUFF,Y
	BEQ	SET_SCROLLPOS

DRAW_BG_100:
	INY

	; AhX
	LDA	BGBUFF,Y
	INY
	STA	PPU_REG_VRAMADDR
	LDA	BGBUFF,Y
	INY
	STA	PPU_REG_VRAMADDR

	; f[^
DRAW_BG_200:
	LDA	BGBUFF,Y
	INY
	STA	PPU_REG_VRAMDATA
	DEX
	BNE	DRAW_BG_200

	; f[^
	LDX	BGBUFF,Y
	BNE	DRAW_BG_100

; ------------------------------------------------ 
;   XN[ʒuݒ                             
; ------------------------------------------------ 
SET_SCROLLPOS:
	LDA	PPU_REG_STATUS
	LDX	<SCROLL_XPOS
	LDY	<SCROLL_YPOS
	STX	PPU_REG_SCROLL
	STY	PPU_REG_SCROLL

; ------------------------------------------------ 
;   pbhԎ擾                                 
; ------------------------------------------------ 
GET_PADSTATE:
	; O
	LDX	<PAD_NORM
	STX	PAD_OLD

	; ʏ
	LDA	#$01
	STA	$4016
	LDA	#$00
	STA	$4016

	LDY	#8
GET_PADSTATE_100:
	LDA	$4016
	STA	<TEMP
	LSR	A
	ORA	<TEMP
	LSR	A
	ROL	<PAD_NORM
	DEY
	BNE	GET_PADSTATE_100

	; x̂
	LDA	<PAD_NORM
	EOR	<PAD_OLD
	AND	<PAD_NORM
	STA	<PAD_ONCE

	; JԂ
GET_PADSTATE_200:
	LDA	<PAD_NORM
	CMP	<PAD_OLD
	BNE	GET_PADSTATE_280

	LDX	#4						; JԂ

	DEC	<PAD_REPTTIME
	BEQ	GET_PADSTATE_2C0				; JEgI

	LDA	#0						; ͂Ȃ
	JMP	GET_PADSTATE_2F0

GET_PADSTATE_280:
	LDX	#16
GET_PADSTATE_2C0:
	STX	<PAD_REPTTIME

GET_PADSTATE_2F0:
	STA	<PAD_REPT

; ------------------------------------------------ 
;   ^XN                                     
; ------------------------------------------------ 
TASK_PROC:
	; ^XN
	LDX	#0
	STX	<RUN_TCB
TASK_PROC_100:
	LDA	TCB_STATUS,X
	BMI	KILL_TASK

	; s
	LDA	TCB_PROC+1,X
	PHA
	LDA	TCB_PROC+0,X
	PHA
	RTS

KILL_TASK:
	; ^XN폜
	LDY	<PREV_TCB
	LDA	TCB_NEXT,X
	STA	TCB_NEXT,Y

	; TCB ԋp
	LDY	<TCB_COUNT
	TXA
	STA	UNUSED_TCB,Y
	INC	<TCB_COUNT

RET_TASK:
	LDY	<RUN_TCB
	STY	<PREV_TCB
	LDX	TCB_NEXT,Y
	STX	<RUN_TCB
	BNE	TASK_PROC_100

; ------------------------------------------------ 
;   ㏈                                         
; ------------------------------------------------ 
	; BG obt@I[ݒ
	LDY	<BGBUFF_COUNT
	LDA	#0
	STA	BGBUFF,Y
	STA	<BGBUFF_COUNT
	RTI




; ------------------------------------------------------------------------------------------------ 
;   ֐                                                                                           

; -------------------------------------------------------------------------------- 
;   ^XN쐬                                                                     
;                                                                                  
;   IN   : X = TCB ԍ                                                            
;   OUT  : Y = 쐬^XN TCB ԍ                                               
;   BREAK: A, Y                                                                    
; -------------------------------------------------------------------------------- 
CRE_TSK:
	; gp TCB 擾
	DEC	<TCB_COUNT
	LDY	<TCB_COUNT
	LDA	UNUSED_TCB,Y
	TAY

	; ^XNXg֒ǉ
	LDA	TCB_NEXT,X
	STA	TCB_NEXT,Y
	TYA
	STA	TCB_NEXT,X
	RTS


; -------------------------------------------------------------------------------- 
;   `iPPU ~̂݌Ăяoj                                       
;                                                                                  
;   IN   : SRCADDR = AhX                                                
;   OUT  : Ȃ                                                                    
;   BREAK: A, Y, SRCADDR                                                           
; -------------------------------------------------------------------------------- 
DRAW_STRING:
	; AhX
	LDY	#1
	LDA	[SRCADDR],Y
	DEY
	STA	PPU_REG_VRAMADDR
	LDA	[SRCADDR],Y
	STA	PPU_REG_VRAMADDR

	LDY	#2
DRAW_STRING_000:
	LDA	[SRCADDR],Y
	BEQ	DRAW_STRING_F00

	STA	PPU_REG_VRAMDATA
	INY
	JMP	DRAW_STRING_000

DRAW_STRING_F00:
	RTS
