
PRG_BANK_MAX		=	4				; vOoN
CHR_BANK		=	PRG_BANK_MAX			; LN^[oN
CHR_BANK_MAX		=	1				; LN^[oN
MIRROR			=	0				; ~[Oݒ
SPRDMA			=	0				; XvCg DMAi0:, 1:Lj
BGBUFF_SIZE		=	64				; BG obt@TCY
TASK_MAX		=	32				; ^XNő吔


	.INESPRG PRG_BANK_MAX/2
	.INESCHR CHR_BANK_MAX
	.INESMIR MIRROR
	.INESMAP 0


	.INCLUDE "common.inc"


; ------------------------------------------------------------------------------------------------ 
;   [y[W                                                                                     

	.ZP

CURSOR_X		.DS	1				; J[\W
CURSOR_Y		.DS	1				; J[\W
CURSOR_POS		.DS	1				; J[\ʒu
SEL_VALUE		.DS	1				; I𒆂̃WX^l




; ------------------------------------------------------------------------------------------------ 
;   BSS                                                                                            

	.BSS

REG_VALUE:		.DS	24				; WX^l




; ------------------------------------------------------------------------------------------------ 
;                                                                                            

	.CODE

INIT:
; ------------------------------------------------ 
;   ʍ쐬                                       
; ------------------------------------------------ 
	LDX	#0
INIT_100:
	LDA	MSG_ADDR,X
	INX
	STA	<(SRCADDR+0)
	LDA	MSG_ADDR,X
	INX
	STA	<(SRCADDR+1)
	JSR	DRAW_STRING

	CPX	#(MSG_ADDREND-MSG_ADDR)
	BNE	INIT_100
	RTS




; ------------------------------------------------------------------------------------------------ 
;   VXe^XN                                                                                 

SYSTEM_TSK:
	; ^XN쐬
	JSR	CRE_TSK
	LDA	#LOW(APU_STATE_TSK-1)
	STA	TCB_PROC+0,Y
	LDA	#HIGH(APU_STATE_TSK-1)
	STA	TCB_PROC+1,Y

	; WX^I֑J
	LDX	<RUN_TCB
	LDA	#LOW(SEL_REG-1)
	STA	TCB_PROC+0,X
	LDA	#HIGH(SEL_REG-1)
	STA	TCB_PROC+1,X

; ------------------------------------------------ 
;   WX^I                                   
; ------------------------------------------------ 
SEL_REG:
	LDA	<CURSOR_POS

	; W
	LDA	<PAD_REPT
	AND	#3
	TAX
	LDA	PAD_ADDSEL,X

	CLC
	ADC	<CURSOR_X
	AND	#3
	STA	<CURSOR_X

	; W
	LDA	<PAD_REPT
	LSR	A
	LSR	A
	AND	#3
	TAX
	LDA	PAD_ADDSEL,X

	CLC
	ADC	<CURSOR_Y
	AND	#7
	TAX
	LDA	CURSOR_YPOS,X
	STA	<CURSOR_Y

	; J[\ʒu
	ASL	A
	ASL	A
	ORA	<CURSOR_X

	; J[\ړȂ`
	CMP	<CURSOR_POS
	BNE	DRAW_CURSOR

	; I
	LDA	<PAD_ONCE
	AND	#PAD_A
	BEQ	SEL_REG_F00

; ------------------------------------------------ 
;                                              
; ------------------------------------------------ 
	; $4014, $4016 Ȃ疳
	LDA	<CURSOR_POS
	CMP	#$14
	BEQ	SEL_REG_F00
	CMP	#$16
	BEQ	SEL_REG_F00

	; l擾
	TAX
	LDA	REG_VALUE,X
	STA	<SEL_VALUE

	; FύX
	LDY	#$90
	JSR	DRAW_HEXVALUE

	; lҏW֑J
	LDX	<RUN_TCB
	LDA	#LOW(EDIT_VALUE-1)
	STA	TCB_PROC+0,X
	LDA	#HIGH(EDIT_VALUE-1)
	STA	TCB_PROC+1,X

SEL_REG_F00:
	JMP	RET_TASK


; ------------------------------------------------ 
;   J[\`                                   
; ------------------------------------------------ 
DRAW_CURSOR:
	; J[\ʒuXV
	LDX	<CURSOR_POS
	STX	<TEMP
	STA	<CURSOR_POS

	LDY	<BGBUFF_COUNT

	; `
	LDA	#1					; f[^
	STA	BGBUFF,Y
	INY

	CLC						; VRAM AhX
	LDA	<CURSOR_POS
	ASL	A
	TAX
	LDA	DUMP_VRAM+1,X
	STA	BGBUFF,Y
	INY
	LDA	DUMP_VRAM+0,X
	STA	BGBUFF,Y
	INY

	LDA	#$2A					; f[^i'*'j
	STA	BGBUFF,Y
	INY

	; 
	LDA	#1					; f[^
	STA	BGBUFF,Y
	INY

	CLC						; VRAM AhX
	LDA	<TEMP
	ASL	A
	TAX
	LDA	DUMP_VRAM+1,X
	STA	BGBUFF,Y
	INY
	LDA	DUMP_VRAM+0,X
	STA	BGBUFF,Y
	INY

	LDA	#0					; f[^
	STA	BGBUFF,Y
	INY

	STY	<BGBUFF_COUNT
	JMP	RET_TASK


; ------------------------------------------------ 
;   lҏW                                         
; ------------------------------------------------ 
EDIT_VALUE:
	LDA	<PAD_ONCE
	AND	#(PAD_A|PAD_B)
	BEQ	EDIT_VALUE_200

	AND	#PAD_A
	BEQ	EDIT_VALUE_100

	; 
	LDA	<SEL_VALUE
	LDX	<CURSOR_POS
	STA	REG_VALUE,X

	; WX^
	STA	$4000,X

EDIT_VALUE_100:
	; FύX
	LDX	<CURSOR_POS
	LDA	REG_VALUE,X
	LDY	#$10
	JSR	DRAW_HEXVALUE

	; WX^I֑J
	LDX	<RUN_TCB
	LDA	#LOW(SEL_REG-1)
	STA	TCB_PROC+0,X
	LDA	#HIGH(SEL_REG-1)
	STA	TCB_PROC+1,X

	JMP	RET_TASK

EDIT_VALUE_200:
	; 
	LDA	<PAD_REPT
	AND	#(PAD_UP|PAD_DOWN|PAD_LEFT|PAD_RIGHT)
	BEQ	EDIT_VALUE_F00

	; 
	TAX
	LDA	PAD_ADDVALUE,X
	BEQ	EDIT_VALUE_F00

	; lXV
	LDY	<SEL_VALUE
	STY	<TEMP
	CLC
	ADC	<SEL_VALUE
	STA	<SEL_VALUE

	; I[o[t[
	BVS	EDIT_VALUE_2C0

	; ]Ȃ
	EOR	<TEMP
	BPL	EDIT_VALUE_280

	LDA	<TEMP
	BPL	EDIT_VALUE_240

	; 255 Nbv
	LDA	#$FF
	STA	<SEL_VALUE
	JMP	EDIT_VALUE_2C0

EDIT_VALUE_240:

	; 0 Nbv
	LDA	#$00
	STA	<SEL_VALUE

EDIT_VALUE_280:
	LDA	<SEL_VALUE
EDIT_VALUE_2C0:
	LDX	<CURSOR_POS
	LDY	#$90
	JSR	DRAW_HEXVALUE

EDIT_VALUE_F00:
	JMP	RET_TASK




; ------------------------------------------------------------------------------------------------ 
;   APU ԕ`^XN                                                                             

APU_STATE_TSK:
	LDA	$4015
	LDX	#$18
	LDY	#$10
	JSR	DRAW_HEXVALUE

	JMP	RET_TASK





; ------------------------------------------------------------------------------------------------ 
;   IRQ/BRK 荞݃T[rX[`                                                               

ISR_IRQBRK:
	RTI




; ------------------------------------------------------------------------------------------------ 
;   ֐                                                                                           

; -------------------------------------------------------------------------------- 
;   16 i̒l`                                                              
;                                                                                  
;   IN   : A = l                                                                  
;          X = ʒu                                                                
;          Y = F                                                                  
;   OUT  : Ȃ                                                                    
;   BREAK: A, X, Y, TEMP 0-1                                                       
; -------------------------------------------------------------------------------- 
DRAW_HEXVALUE:
	STA	<(TEMP+0)
	STY	<(TEMP+1)

	LDY	<BGBUFF_COUNT

	; f[^
	LDA	#2
	STA	BGBUFF,Y
	INY

	; VRAM AhX
	CLC
	TXA
	ASL	A
	TAX
	LDA	DUMP_VRAM+1,X
	STA	BGBUFF,Y
	INY
	LDA	DUMP_VRAM+0,X
	ADC	#1
	STA	BGBUFF,Y
	INY

	; ʂSrbg
	LDA	<(TEMP+0)
	LSR	A
	LSR	A
	LSR	A
	LSR	A
	AND	#15
	CLC
	ADC	<(TEMP+1)
	STA	BGBUFF,Y
	INY

	; ʂSrbg
	LDA	<(TEMP+0)
	AND	#15
	ADC	<(TEMP+1)
	STA	BGBUFF,Y
	INY

	STY	<BGBUFF_COUNT
	RTS




; ------------------------------------------------------------------------------------------------ 
;   f[^                                                                                         

	.BANK	PRG_BANK_MAX-1
	.ORG	$FE00

PAD_ADDSEL	.DB	0, 1,-1, 0

PAD_ADDVALUE	.DB	  0,  1, -1,  0
		.DB	-16,-15,-17,-16
		.DB	 16, 17, 15, 16
		.DB	  0,  1, -1,  0

CURSOR_YPOS	.DB	0, 1, 2, 3, 4, 5, 0, 5

DUMP_XPOS	.DB	48+(0*32)
		.DB	48+(1*32)
		.DB	48+(2*32)
		.DB	48+(3*32)
DUMP_YPOS	.DB	24+(0* 8)
		.DB	24+(1* 8)
		.DB	24+(2* 8)
		.DB	24+(3* 8)
		.DB	24+(4* 8)
		.DB	24+(5* 8)

DUMP_VRAM	.DW	PPU_NT0+(6+(3*32)), PPU_NT0+(10+(3*32)), PPU_NT0+(14+(3*32)), PPU_NT0+(18+(3*32))
		.DW	PPU_NT0+(6+(4*32)), PPU_NT0+(10+(4*32)), PPU_NT0+(14+(4*32)), PPU_NT0+(18+(4*32))
		.DW	PPU_NT0+(6+(5*32)), PPU_NT0+(10+(5*32)), PPU_NT0+(14+(5*32)), PPU_NT0+(18+(5*32))
		.DW	PPU_NT0+(6+(6*32)), PPU_NT0+(10+(6*32)), PPU_NT0+(14+(6*32)), PPU_NT0+(18+(6*32))
		.DW	PPU_NT0+(6+(7*32)), PPU_NT0+(10+(7*32)), PPU_NT0+(14+(7*32)), PPU_NT0+(18+(7*32))
		.DW	PPU_NT0+(6+(8*32)), PPU_NT0+(10+(8*32)), PPU_NT0+(14+(8*32)), PPU_NT0+(18+(8*32))
		.DW	PPU_NT0+(24+(8*32))

MSG_000		.DW	PPU_NT0+(1+(1*32))
		.DB	"APU REG:", 0
MSG_001		.DW	PPU_NT0+(1+(3*32))
		.DB	"4000 *00  00  00  00", 0
MSG_002		.DW	PPU_NT0+(1+(4*32))
		.DB	"4004  00  00  00  00", 0
MSG_003		.DW	PPU_NT0+(1+(5*32))
		.DB	"4008  00  00  00  00", 0
MSG_004		.DW	PPU_NT0+(1+(6*32))
		.DB	"400C  00  00  00  00", 0
MSG_005		.DW	PPU_NT0+(1+(7*32))
		.DB	"4010  00  00  00  00", 0
MSG_006		.DW	PPU_NT0+(1+(8*32))
		.DB	"4014  --  00  --  00", 0

MSG_ADDR	.DW	MSG_000
		.DW	MSG_001
		.DW	MSG_002
		.DW	MSG_003
		.DW	MSG_004
		.DW	MSG_005
		.DW	MSG_006
MSG_ADDREND:

INITPALDAT:	.INCBIN "font.pal"




; ------------------------------------------------------------------------------------------------ 
;   LN^[ ROM                                                                               

	.DATA
	.BANK	CHR_BANK

	.INCBIN	"font.chr"
